<script setup lang="ts">
import {
  type Field,
  type Subfield,
  type StateMultiEnum,
  type ComputedPostMultiEnum,
  type PrecomputedMultiEnum,
} from "~/lib/filters";

const props = defineProps<{
  filterFields: Field[] | Subfield[];
  filterState: StateMultiEnum;
  filterComputedPre: PrecomputedMultiEnum;
  filterComputedPost: ComputedPostMultiEnum;
}>();

const search = ref<string>();

const availableFieldLabels = computed(() => {
  return props.filterComputedPost.unconfiguredFields.filter((fieldLabel) =>
    props.filterFields.map((field) => field.label).includes(fieldLabel),
  );
});

const filteredOptions = computed(() => {
  let filteredFields = availableFieldLabels.value;

  if (search.value) {
    filteredFields = filteredFields.filter((field) =>
      field.toLowerCase().includes(search.value!),
    );
  }

  return filteredFields;
});

function getField(label: string) {
  for (const field of props.filterFields) {
    if (field.label == label) {
      return field;
    }
  }
  throw new Error(`Field ${label} not found`);
}

const configuredFields = computed(() => {
  const configuredFields = Object.entries(props.filterState.configuredFields)
    .filter(([key, selected]) =>
      props.filterFields.some((field) => field.label === key),
    )
    .map(([key, selected]) => ({ key, selected, field: getField(key) }));

  return configuredFields;
});

function filterSubfields(field: Field) {
  if (!field.subfields) return;

  return field.subfields.filter((subfield) => {
    const selected = props.filterState.configuredFields[field.label];
    if (selected) return selected.includes(subfield.if);
    return false;
  });
}

function onNewFieldSelect(option: string) {
  if (!option) return;
  search.value = "";
  props.filterState.configuredFields[option] = [];
}

function onFieldRemove(field: Field) {
  delete props.filterState.configuredFields[field.label];
  for (const subfield of field.subfields ?? []) {
    delete props.filterState.configuredFields[subfield.label];
  }
}
</script>

<template>
  <div class="control custom-multi-enum-multiple">
    <!-- Configured fields -->
    <template v-for="{ key, selected, field } in configuredFields" :key="key">
      <div class="custom-multi-enum-multiple-field">
        <div>
          <span>{{ key }}</span>
          <o-dropdown
            class="custom-dropdown"
            v-model="filterState.configuredFields[key]"
            multiple
            position="bottom-left"
          >
            <template #trigger>
              <o-button
                class="custom-dropdown-button"
                :variant="selected.length === 0 ? 'primary' : 'normal'"
                type="button"
                icon-right="caret-down"
              >
                <span class="custom-dropdown-button-text">
                  {{
                    selected.length > 0
                      ? selected.join(", ")
                      : "Please select at least one"
                  }}
                </span>
              </o-button>
            </template>

            <o-dropdown-item
              v-for="option in filterComputedPre.fieldOptions[key]"
              :key="option"
              :value="option"
            >
              {{ option }}
            </o-dropdown-item>
          </o-dropdown>
        </div>
        <o-button
          variant="danger"
          type="button"
          icon-left="trash"
          @click="onFieldRemove(field)"
        />
      </div>

      <div v-if="filterSubfields(field)?.length" class="custom-subfields">
        <FilterMultiEnum
          :filter-fields="filterSubfields(field)!"
          :filter-state="filterState"
          :filter-computed-pre="filterComputedPre"
          :filter-computed-post="filterComputedPost"
        />
      </div>

      <div class="custom-separator"></div>
    </template>

    <!-- Add new field -->
    <div class="custom-multi-enum-multiple-add">
      <o-autocomplete
        @select="onNewFieldSelect"
        v-model="search"
        :data="filteredOptions"
        :clearOnSelect="true"
        :openOnFocus="true"
        :disabled="availableFieldLabels.length === 0"
        placeholder="Search for a field"
        icon="plus"
      />
    </div>
  </div>
</template>

<style scoped lang="scss">
@import "bulma/sass/utilities/mixins.sass";

.custom-multi-enum-multiple {
  display: grid;
  grid-template-columns: 1fr;
  gap: 1rem;
  align-items: center;

  .custom-multi-enum-multiple-field {
    display: grid;
    grid-template-columns: 1fr auto;
    gap: 1rem;
    align-items: center;

    & > :first-child {
      display: grid;
      align-items: center;
      gap: 0.5rem;
    }
  }

  .custom-dropdown {
    min-width: 50px;

    // Allow dropdown to shrink with ellipsis
    & * {
      // 24px is width of the icon
      min-width: 24px;
    }
  }

  .custom-dropdown-button {
    width: 100%;
  }
  :global(.custom-dropdown-button > span > span) {
    overflow: hidden;
    text-overflow: ellipsis;
  }

  .custom-subfields {
    margin-top: -1rem;
    //margin-bottom: -1rem;
    //margin-left: 1rem;
    padding-top: 1rem;
    padding-left: 1rem;
    //padding-bottom: 1rem;
    border-left: 3px solid $primary;
    //border-bottom-left-radius: 1rem;
    //border-top-left-radius: 1rem;
  }

  .custom-separator {
    height: 1px;
    background: $grey-lighter;
  }

  .custom-multi-enum-multiple-add {
    display: grid;
    grid-template-columns: 1fr;

    & > :first-child {
      display: grid;
    }
  }
}

@include from(600px) {
  .custom-multi-enum-multiple {
    .custom-multi-enum-multiple-field {
      & > :first-child {
        grid-template-columns: 1fr auto;
        gap: 1rem;

        & > span:first-child {
          //word-break: keep-all;
          white-space: nowrap;
        }
      }
    }

    .custom-separator {
      display: none;
    }
  }
}
</style>
